# nomad-hawk-cli
This is the API descriptor for the Nomad Hawk API, responsible for tracking and analytics.

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.1.0
- Package version: 0.1.0
- Build package: io.swagger.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import nomad_hawk_cli 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import nomad_hawk_cli
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import nomad_hawk_cli
from nomad_hawk_cli.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_key
configuration = nomad_hawk_cli.Configuration()
configuration.api_key['x-api-key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-api-key'] = 'Bearer'

# create an instance of the API class
api_instance = nomad_hawk_cli.TrackApi(nomad_hawk_cli.ApiClient(configuration))
body = nomad_hawk_cli.Event() # Event | Event to track

try:
    # Record an individual event
    api_response = api_instance.track(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling TrackApi->track: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://nomad.samarkand-global.cn/hawk*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*TrackApi* | [**track**](docs/TrackApi.md#track) | **POST** /track | Record an individual event
*TrackApi* | [**track_with_store**](docs/TrackApi.md#track_with_store) | **POST** /track/{store_id} | Record an individual event


## Documentation For Models

 - [ApiResponse](docs/ApiResponse.md)
 - [ApiResponseConnectorResponse](docs/ApiResponseConnectorResponse.md)
 - [ApiResponseData](docs/ApiResponseData.md)
 - [Event](docs/Event.md)
 - [EventItem](docs/EventItem.md)


## Documentation For Authorization


## api_key

- **Type**: API key
- **API key parameter name**: x-api-key
- **Location**: HTTP header


## Author

paul@samarkand.global

